using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using System.Drawing.Printing;

namespace PrintGrid
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl2;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem miPrintPreview;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl2 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.miPrintPreview = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.gridControl2)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl2
			// 
			this.gridControl2.ColCount = 50;
			this.gridControl2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridControl2.Location = new System.Drawing.Point(0, 0);
			this.gridControl2.Name = "gridControl2";
			this.gridControl2.RowCount = 50;
			this.gridControl2.Size = new System.Drawing.Size(800, 193);
			this.gridControl2.TabIndex = 1;
			this.gridControl2.Text = "gridControl2";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.miPrintPreview});
			this.menuItem1.Text = "File";
			// 
			// miPrintPreview
			// 
			this.miPrintPreview.Index = 0;
			this.miPrintPreview.Text = "Print Preview";
			this.miPrintPreview.Click += new System.EventHandler(this.miPrintPreview_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(800, 193);
			this.Controls.Add(this.gridControl2);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl2)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void miPrintPreview_Click(object sender, System.EventArgs e)
		{
			TestPrintDocument pd = new TestPrintDocument(this.gridControl2,true);
			PrintPreviewDialog dlg = new PrintPreviewDialog() ;
			dlg.Document = pd;
			dlg.ShowDialog();
		}
	}

	public class TestPrintDocument : GridPrintDocument
	{
		private GridControl m_prGrid;
		private int startCol = 1;
		private int endCol = 1;

		public TestPrintDocument(GridControl printGrid, bool bPrintview) : base(printGrid,bPrintview)
		{
			m_prGrid = printGrid;
		}
		protected override void OnPrintPage(PrintPageEventArgs e)
		{
			startCol = endCol;
			endCol = startCol;
			while (endCol < this.m_prGrid.ColCount 
				&& this.m_prGrid.ColWidths[0] + this.m_prGrid.ColWidths.GetTotal(startCol, endCol)
				   < 600)
				endCol += 1;

			this.m_prGrid.QueryColWidth += new GridRowColSizeEventHandler(m_prGrid_QueryColWidth);

			int width = this.m_prGrid.ColWidths[0] + this.m_prGrid.ColWidths.GetTotal(startCol, endCol-1);

			Region r = e.Graphics.Clip; // Save clip region
			//m_prGrid.GridBounds = new Rectangle(10, 10, 600, 300);
			m_prGrid.GridBounds = new Rectangle(10, 10, width, 300);

			e.Graphics.IntersectClip(new Rectangle(10, 10, 700-50, 700-50));
			m_prGrid.DrawGrid(e.Graphics, m_prGrid.GridBounds, false);
			e.Graphics.DrawRectangle(System.Drawing.Pens.Black,m_prGrid.GridBounds);
			e.Graphics.Clip = r; // Reset clip region

			m_prGrid.ResetGridBounds();

			this.m_prGrid.QueryColWidth -= new GridRowColSizeEventHandler(m_prGrid_QueryColWidth);

			if(endCol < this.m_prGrid.ColCount)
				e.HasMorePages = true;
			else
				e.HasMorePages = false;
		}

		private void m_prGrid_QueryColWidth(object sender, GridRowColSizeEventArgs e)
		{
			if(e.Index > 0 && (e.Index <startCol || e.Index >= endCol))
			{
				e.Size = 0;
				e.Handled = true;
			}
		}
	}
}
